package com.ruoyi.web.controller.app_course;

import cn.hutool.core.date.DateUtil;
import com.ruoyi.RestResponse;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.course.domain.Appointment;
import com.ruoyi.course.domain.AppointmentVo;
import com.ruoyi.course.mapper.AppointmentMapper;
import com.ruoyi.course.service.AppointmentServiceImpl;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 课程 前端控制器
 * </p>
 *
 * @author xhj
 * @since 2022-09-22
 */
@Api(tags = "课程", description = "提供课程相关的API")
@RestController
@RequestMapping("/api/appointment")
public class AppointmentAppController extends BaseController {

    @Autowired
    AppointmentServiceImpl appointmentService;

    @Autowired
    AppointmentMapper mapper;


//    @PostMapping("/getAppointmentList")
    public RestResponse getAppointmentList(@RequestBody Map map) {
//        List<Course> list = appointmentService.getList(map);
//        return  new RestResponse().setData(list);
        return  RestResponse.success().setData(appointmentService.findList(map));
    }

//    @PostMapping("/updateAppointment")
    public RestResponse updateAppointment(@RequestBody Appointment appointment) {
        String username = SecurityUtils.getUsername();
        appointment.setUpdateUser(username);
//        LocalDateTime now= ;
        appointment.setUpdateTime(DateUtil.parseLocalDateTime(DateUtil.now(),"yyyy-MM-dd HH:mm:ss"));
        appointmentService.updateById(appointment);
        return  RestResponse.success();
    }

    /**
     * 预约课程
     * @param appointment
     * @return
     */
//    @PostMapping("/yy")
    public RestResponse yy(@RequestBody Appointment appointment) {
        appointment.setCreateTime(DateUtil.parseLocalDateTime(DateUtil.now(),"yyyy-MM-dd HH:mm:ss"));
        appointmentService.save(appointment);
        return  RestResponse.success();
    }

    //我的预约
    //预约成功
    //预约失败
    @PostMapping("/appointments")
    public RestResponse appointments(HttpServletRequest request) {
        Long userId= Long.parseLong(request.getAttribute("userId").toString());
        Map map=new HashMap();
        map.put("consumerId",userId);
        List<AppointmentVo> list=appointmentService.findList(map);
        List<AppointmentVo>  list1=new ArrayList<>();//预约中
        List<AppointmentVo>  list2=new ArrayList<>();//预约成功
        List<AppointmentVo>  list3=new ArrayList<>();//预约失败
        List<AppointmentVo>  list4=new ArrayList<>();//取消预约
        for (AppointmentVo a:list){
            if (a.getFlag()==0){
                list1.add(a);
                continue;
            }
            if (a.getFlag()==1){
                list2.add(a);
                continue;
            }
            if (a.getFlag()==2){
                list3.add(a);
                continue;
            }
            if (a.getFlag()==3){
                list4.add(a);
            }
        }
        map.clear();
        map.put("list1",list1);
        map.put("list2",list2);
        map.put("list3",list3);
        map.put("list4",list4);
        return  RestResponse.success().setData(map);
    }


    //取消预约
    @PostMapping("/cancel")
    public RestResponse cancel(@RequestBody Appointment appointment) {
        appointment.setUpdateTime(DateUtil.parseLocalDateTime(DateUtil.now(),"yyyy-MM-dd HH:mm:ss"));
        int i= mapper.cancel(appointment);
        return  RestResponse.success().setMessage(i==0?"修改失败，当前状态无法取消预约！":"成功！");
    }





}

