package com.ruoyi.web.controller.app_course;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.RestResponse;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.entity.SysDictData;
import com.ruoyi.common.utils.JpushClientUtil;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.course.domain.*;
import com.ruoyi.course.service.ConsumerCourseServiceImpl;
import com.ruoyi.course.service.CourseLogServiceImpl;
import com.ruoyi.course.service.CourseServiceImpl;
import com.ruoyi.course.service.HistoryMessageServiceImpl;
import com.ruoyi.search.domain.MemberUser;
import com.ruoyi.search.service.MemberUserServicelmpl;
import com.ruoyi.shop.domain.ShopOrder;
import com.ruoyi.shop.domain.ShopOrderItem;
import com.ruoyi.shop.service.impl.ShopOrderItemServiceImpl;
import com.ruoyi.shop.service.impl.ShopOrderServiceImpl;
import com.ruoyi.system.domain.SysUserRole;
import com.ruoyi.system.mapper.SysUserRoleMapper;
import com.ruoyi.system.service.ISysDictDataService;
import com.ruoyi.web.util.PayUtil;
import com.ruoyi.web.util.SnowFlake;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 课程 前端控制器
 * </p>
 *
 * @author xhj
 * @since 2022-09-22
 */
@RestController
@RequestMapping("/api/course")
public class CourseAppController extends BaseController {

    @Autowired
    CourseServiceImpl courseService;
    @Autowired
    HistoryMessageServiceImpl historyMessageService;
    @Autowired
    CourseLogServiceImpl courseLogService;
    @Autowired
    ISysDictDataService iSysDictDataService;
    @Autowired
    MemberUserServicelmpl memberUserService;
    @Resource
    private ShopOrderServiceImpl orderService;
    @Resource
    private ShopOrderItemServiceImpl itemService;
    @Resource
    private ConsumerCourseServiceImpl consumerCourseService;
    @Resource
    private SysUserRoleMapper sysUserRoleMapper;


    /**
     *
     * courseName 名字
     * courseType 课程分类  //1 传入1
     * memberType[]  会籍数组
     * @param map
     * @return   显示得内容 是 courseType1   字典
     */
    @PostMapping("/list")
    public RestResponse list(@RequestBody Map map) {
        map.put("releases",1);
        List<Course> list = courseService.getList(map);
        return  new RestResponse().setData(list);
    }


    /**
     * 字典？
     * @param map
     * @return
     */
    @PostMapping("/listByCourseType1")
    public RestResponse listByCourseType1(@RequestBody Map map) {
        SysDictData sysDictData= new SysDictData();
        sysDictData.setDictType("yj_source_pt_type");
        sysDictData.setMerchantId(SecurityUtils.getMerchanId());
        return RestResponse.success().setData(iSysDictDataService.selectDictDataList(sysDictData));

    }


    /**
     * 预约课程
     * @param appointment
     * @return
     */
//    @PostMapping("/yyCourse")
    public RestResponse yyCourse(@RequestBody Appointment appointment) {
        courseService.yyCourse(appointment);
        return RestResponse.success();
    }


    /**
     * courseId  课程id  会员课的id
     * @param map
     * @return  userName 教练姓名  course_names课程名称（进修课提升）   memberType  类型（小班课） course_picture 图片
     * memberType 必须传1    courseType1 = 会员/1对1    具体根据courseType 查询
     */
    @PostMapping("/listLog")
    public RestResponse listLog(@RequestBody Map map) {
        //todo
        List<CourseLogVo> list = courseService.getListLog(map);
        return  new RestResponse().setData(list);
    }

    /**
     * 显示课程表
     *
     * @param map  date 当天的日期    courseId 课程分类id
     * @return
     * 2022.11.30改（xn）
     */
    @PostMapping("/listLogDate")
    public RestResponse listLogDate(@RequestBody Map map) {
//        Map map1 = courseService.listLogDate(map);
        map.put("userId",null);
        Map map1 = courseService.listLogDate1(map);
        return  new RestResponse().setData(map1);
    }

    @PostMapping("/listLogDateForMember")
    public RestResponse listLogDateForMember(@RequestBody Map map,HttpServletRequest request) {
        Long userId= Long.parseLong(request.getAttribute("userId").toString());
        //        Map map1 = courseService.listLogDate(map);
        map.put("userId",userId);
        Map map1 = courseService.listLogDate1(map);
        return  new RestResponse().setData(map1);
    }


    @PostMapping("/getTeacherList")
    public RestResponse getTeacherList(@RequestBody Map map) {
//        sysUserService.selectUserList()

        List<SysUserRole> sysUserRoles = sysUserRoleMapper.selectALLByRole(map.get("merchantId").toString());
        if(sysUserRoles.size()==0){
            return  RestResponse.failure("没有教练信息");
        }
        return  RestResponse.success().setData(sysUserRoles);
    }


    /**
     *
     * app服务-大咖课/教练培训
     * @param course
     * @return
     * @author xn
     */
//    @PostMapping("/listForService")
    public RestResponse listForService(@RequestBody Course course) {
        course.setReleases(1);
        List<Course> list = courseService.listForApp(course);
        return  new RestResponse().success().setData(list);
    }

    /**
     *
     * app服务-特色课程详情
     * @param course
     * @return
     * @author xn
     */
//    @PostMapping("/getOne")
    public RestResponse getOne(@RequestBody Course course) {
        Course c = courseService.listForApp(course).get(0);
        return  new RestResponse().success().setData(c);
    }


    /**
     * 课程详情(未登录)
     * @param courseLogVo
     * @return
     */
    @PostMapping("/getDetail")
    public RestResponse getDetail(@RequestBody CourseLogVo courseLogVo) {
        CourseLog courseLog =courseLogService.getById(courseLogVo.getId());
        Course course =courseService.getById(courseLog.getCourseId());
        courseLog.generateMemberNum();
        Map map=new HashMap();
        map.put("course",course);
        courseLog.setVideoLong("1");
        map.put("courseLog",courseLog);
        return  new RestResponse().success().setData(map);
    }

    /**
     * 登录后，查看付费视频课
     * @param courseLogVo
     * @param request
     * @return
     */
    @PostMapping("/watchLongVideo")
    public RestResponse watchLongVideo(@RequestBody CourseLogVo courseLogVo, HttpServletRequest request) {
        Long userId= Long.parseLong(request.getAttribute("userId").toString());
        CourseLog courseLog =courseLogService.getById(courseLogVo.getId());
        Course course =courseService.getById(courseLog.getCourseId());
        Map map=new HashMap();
        map.put("course",course);
        map.put("courseLog",courseLog);
        //判断是否购买过
        Long l= consumerCourseService.count(new QueryWrapper<ConsumerCourse>()
                .eq("consumer_id",userId)
                .eq("course_log_id",courseLogVo.getId()));
        if (l<1l){
            courseLog.setVideoLong("1"); //页面
            return  new RestResponse().success().setData(map);
        }
        return  new RestResponse().success().setData(map);
    }

    /**
     * 预约课程1
     * @param appointment
     * @return
     */
    @PostMapping("/yyCourse1")
    @Transactional(rollbackFor = RuntimeException.class)
    public RestResponse yyCourse1(@RequestBody Appointment appointment, HttpServletRequest request) {
        Long userId= Long.parseLong(request.getAttribute("userId").toString());
        //查看校验课程是否符合预约条件
        CourseLog log=courseLogService.getById(appointment.getCourseLogId());
        if ( DateUtil.parse(log.getStartDate()+" "+log.getStartTime(),"yyyy-MM-dd HH:mm").before(DateUtil.date())){
            return new RestResponse().setSuccess(false).setMessage("该课程已过期，请选择其他课程！");
        }
        if (log.getNumber()==log.getAppointmentNum()){
            return new RestResponse().setSuccess(false).setMessage("该课程预约已满，请选择其他课程！");
        }

        log.generateMemberNum();
        if (ObjectUtil.isNotEmpty(log.getMemberNum())){

            //判断是否为会员
           List<MemberUser> memberUsers=memberUserService.list(new QueryWrapper<MemberUser>().eq("consumer_id",userId));
           if (ObjectUtil.isEmpty(memberUsers)){
               return new RestResponse().setSuccess(false).setMessage("该课程为会员课，请加入相应会籍后预约！");
           }

           int flag=0;
            for (Object memberId:log.getMemberNum()){
                 int id=Integer.parseInt(memberId.toString());
                 for (MemberUser user:memberUsers){
                     //判断会员会籍与课程会籍是否相符
                     if (user.getMemberId()==id){
                         //如果上课日期在会员有效期之内
                         if (DateUtil.parse(log.getStartDate(),"yyyy-MM-dd").before(
                                 DateUtil.parse(user.getValidityTime(),"yyyy-MM-dd"))){
                                flag=1;
                         }
                     }
                 }
            }
            if (flag==0){
                return new RestResponse().setSuccess(false).setMessage("该课程为会员课，您的会籍类型与课程不符，请加入相应会籍后预约！");
            }
        }
        appointment.setPhone(request.getAttribute("phone").toString());
        courseService.yyCourse1(appointment);

        //给教练发送消息，提醒确认
        Context context=courseService.getTeacherPhone(appointment.getCourseLogId());
        String notification_title=context.getUserName()+"教练，您有一条课程预约";
        String msg_content="学员："+request.getAttribute("phone").toString()+"预约您的课程,请登录后台处理！";

        try {
            JpushClientUtil.sendMessage(context.getPhonenumber(),notification_title,msg_content);
        } catch (Exception e) {
            e.printStackTrace();
        }

        //消息记录
        HistoryMessage message=new HistoryMessage();
        message.setPhone(context.getPhonenumber());
        message.setNotificationTitle(notification_title);
        message.setMsgContent(msg_content);
        message.setSendTime(DateUtil.now());
        historyMessageService.save(message);
        return RestResponse.success();
    }

    /**
     * 购买课程
     * @param courseLogVo
     * @param request
     * @return
     * @throws Exception
     */
    @PostMapping("/createOrderForCourse")
    @Transactional(rollbackFor = RuntimeException.class)
    public RestResponse createOrderForCourse(@RequestBody CourseLogVo courseLogVo, HttpServletRequest request) throws Exception{
        Long userId= Long.parseLong(request.getAttribute("userId").toString());
        //判断是否购买过
        long count= consumerCourseService.count(new QueryWrapper<ConsumerCourse>()
                                                    .eq("consumer_id",userId)
                                                    .eq("course_log_id",courseLogVo.getId()));
          if (count>0l){
              return  new RestResponse().setSuccess(false).setMessage("课程已购买过，请到 我的->我的课程 中查看！");
          }


        //生成订单（支付中）
        ShopOrder order=new ShopOrder();
        order.setOrderSn(SnowFlake.getOrder()+"");//订单号
        order.setBusinessId(courseLogVo.getStroreId());//商户
        order.setIdUser(userId);//客户id
        order.setMobile(request.getAttribute("phone").toString());//收件人电话（客户电话）
        order.setCreateTime(DateUtil.parseLocalDateTime(DateUtil.now(),"yyyy-MM-dd HH:mm:ss"));
        order.setOrderType(3);//订单类型：1.商品 2.会籍 3.课程
        order.setPayType("微信支付");
        order.setTradeAmount(courseLogVo.getCoursePrice());//TradeAmount交易金额  MemberPrice价格

        orderService.save(order);

        //生成订单详情
        ShopOrderItem item=new ShopOrderItem();
        item.setIdOrder(order.getId());//订单id
        item.setIdSouseLog(courseLogVo.getId());//开课记录id
        item.setTotalPrice(courseLogVo.getCoursePrice());//总价
        item.setThumbnail(courseLogVo.getCoursePicture());//缩略图
        item.setType("3");//1 商品 2 会籍 3  课程
        item.setCourseContext(courseLogVo.getCourseContext());//课程内容
        item.setCourseType(courseLogVo.getCourseType());//2大咖课 3教练培训
        item.setCourseNames(courseLogVo.getCourseNames());
        itemService.save(item);

        //单位： 元 转换成 分
        BigDecimal total=courseLogVo.getCoursePrice().multiply(new BigDecimal(100));
        Map map=new HashMap();

        //0元
        if (total.equals(BigDecimal.ZERO)){
            //支付成功 给用户添加课程 TODO

            map.put("timeStamp","1");
            return new   RestResponse().setSuccess(true).setMessage("成功").setData(map);
        }
        map= PayUtil.creatOrder(total.setScale(1, RoundingMode.HALF_UP).intValue(),order.getOrderSn());
        return new   RestResponse().setSuccess(true).setMessage("成功").setData(map);
    }


    //视频以流的方式播放
//    @RequestMapping(value = "/longView", method = {RequestMethod.GET})
    @GetMapping("/longView")
    public void imageView1(HttpServletRequest request, HttpServletResponse httpServletResponse){
        String  fileName="/profile/upload/2022/11/10/WeChat_20221110133401_20221110133433A027.mp4";

        byte[] bytes = file2byte("../ruoyi/uploadPath"+fileName.substring(8));

        httpServletResponse.setContentType("application/octet-stream");
        httpServletResponse.setContentLength(bytes.length);
        try {
            httpServletResponse.getOutputStream().write(bytes);
        } catch (IOException e) {
            System.out.println("IO异常----");
        }
    }

    public  byte[] file2byte(String filePath) {
        byte[] buffer = null;
        try {
            File file = new File(filePath);
            FileInputStream fis = new FileInputStream(file);
            ByteArrayOutputStream bos = new ByteArrayOutputStream();
            byte[] b = new byte[1024];
            int n;
            while ((n = fis.read(b)) != -1) {
                bos.write(b, 0, n);
            }
            fis.close();
            bos.close();
            buffer = bos.toByteArray();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return buffer;
    }

}

