package com.ruoyi.web.controller.app_course;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.RestResponse;
import com.ruoyi.course.domain.HistoryMessage;
import com.ruoyi.course.service.HistoryMessageServiceImpl;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * 我的消息
 */
@Api(tags = "我的消息", description = "提供我的消息相关的API")
@RestController
@RequestMapping("/api/historyMessage")
public class HistoryMessageController {


    @Autowired
    HistoryMessageServiceImpl historyMessageService;

    @ApiOperation("我的消息列表")
    @PostMapping("/getMessages")
    public RestResponse getMessages(HttpServletRequest request){
       List<HistoryMessage> list= historyMessageService.list(new QueryWrapper<HistoryMessage>()
               .eq("phone",request.getAttribute("phone").toString())
                .eq("releases",true));
       return new RestResponse().setSuccess(true).setData(list);
    }

    @ApiOperation("消息详情")
    @PostMapping("/getOne")
    public RestResponse getOne(@RequestBody  HistoryMessage message){
        HistoryMessage historyMessage= historyMessageService.getById(message.getId());
        return new RestResponse().setSuccess(true).setData(historyMessage);
    }

    @ApiOperation("删除消息")
    @PostMapping("/remove")
    public RestResponse remove(@RequestBody  HistoryMessage message){
        message.setReleases(false);
        historyMessageService.updateById(message);
        return new RestResponse().setSuccess(true);
    }

}
