package com.ruoyi.web.controller.app_shop;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.RestResponse;
import com.ruoyi.course.domain.CourseLog;
import com.ruoyi.course.service.CourseLogServiceImpl;
import com.ruoyi.shop.domain.YjCourseLp;
import com.ruoyi.shop.service.impl.YjCourceLpMenuServiceImpl;
import com.ruoyi.shop.service.impl.YjCourceLpServiceImpl;
import com.ruoyi.shop.service.impl.YjMerchantServiceImpl;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;
@Api(tags = "瑜伽流派", description = "提供瑜伽流派相关的API")
@RestController
@RequestMapping("/api/courseLp")
public class CourceLpController {
    @Resource
    private YjCourceLpServiceImpl service;
    @Resource
    private YjMerchantServiceImpl merchantService;
    @Resource
    private YjCourceLpMenuServiceImpl menuService;
    @Resource
    private CourseLogServiceImpl courseLogService;

    /**
     * 列表
     * @param lp
     * @return
     */
    @PostMapping("/list")
    @ApiOperation("获取瑜伽流派 列表")
    public RestResponse list(@RequestBody YjCourseLp lp){
        List<YjCourseLp> list=service.list(new QueryWrapper<YjCourseLp>()
                .eq("merchant_id", lp.getMerchantId())
                .eq("enabled",true)
                .orderByDesc("modify_time")
        );
        return new RestResponse().setSuccess(true).setMessage("成功").setData(list);
    }

    @ApiOperation("获取当前瑜伽流派下的课程")
    @PostMapping("/courseList")
    public RestResponse courseList(@RequestBody YjCourseLp lp){
//   课程分类courseType 是否显示releases
        List<YjCourseLp> list=service.list(new QueryWrapper<YjCourseLp>()
                .eq("merchant_id", lp.getMerchantId())
                .eq("enabled",true)
                .orderByDesc("modify_time")
        );
        list.forEach(l->{
            l.setCourseType(lp.getCourseType());
            l.setReleases(true);
            List<CourseLog> courseList=courseLogService.list(new QueryWrapper<CourseLog>()
                                     .select("id","course_id","course_names","course_price","course_picture","course_type")
                                     .eq("course_type",lp.getCourseType())//课程类型 2大咖课 3教练培训
                                     .eq("releases",true) //上架
                                     .eq("lp_id",l.getId())//流派
                                  );
            l.setCourseList(courseList);
        });
        return new RestResponse().setSuccess(true).setMessage("成功").setData(list);
    }

}
