package com.ruoyi.web.controller.app_shop;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.RestResponse;
import com.ruoyi.shop.domain.ShopGoods;
import com.ruoyi.shop.domain.ShopGoodsCategory;
import com.ruoyi.shop.mapper.ShopGoodsMapper;
import com.ruoyi.shop.service.impl.ShopGoodsCategoryServiceImpl;
import com.ruoyi.shop.service.impl.ShopGoodsServiceImpl;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

@Api(tags = "商品", description = "提供商品相关的API")
@RestController
@RequestMapping("/api/goods")
public class GoodsController {
    @Resource
    private ShopGoodsServiceImpl service;

    @Resource
    private ShopGoodsCategoryServiceImpl categoryService;

    @Resource
    private ShopGoodsMapper goodsMapper;


    @ApiOperation("商品类别")
    @PostMapping("/getGoodsCategory")
    public RestResponse getGoodsCategory(@RequestBody ShopGoodsCategory category){
       List<ShopGoodsCategory> categoryList=categoryService.list(new QueryWrapper<ShopGoodsCategory>()
                .eq("business_id",category.getBusinessId())
                .eq("pid","0")
                .eq("display",true)
                .eq("is_delete",false));
        return new RestResponse().setSuccess(true).setMessage("成功").setData(categoryList);
    }

    @ApiOperation("商品列表")
    @PostMapping("/getGoods")
    public RestResponse getGoods(@RequestBody ShopGoodsCategory category){
        List<ShopGoods> goods=goodsMapper.getByPid(category.getId());
        return new RestResponse().setSuccess(true).setMessage("成功").setData(goods);
    }

    @ApiOperation("商品详情")
    @PostMapping("/getOne")
    public RestResponse getOne(@RequestBody ShopGoods goods){
        return new RestResponse().setSuccess(true).setMessage("成功").setData(service.getById(goods.getId()));
    }

}
