package com.ruoyi.web.controller.app_shop;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.RestResponse;
import com.ruoyi.shop.domain.YjIndex;
import com.ruoyi.shop.domain.YjMerchant;
import com.ruoyi.shop.service.impl.YjIndexServiceImpl;
import com.ruoyi.shop.service.impl.YjMerchantServiceImpl;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;
@Api(tags = "首页", description = "提供首页信息相关的API")
@RestController
@RequestMapping("/api/index")
public class IndexController {

    @Resource
    private YjIndexServiceImpl indexService;
    @Resource
    private YjMerchantServiceImpl merchantService;


    //商户list
    @ApiOperation("门店列表")
    @PostMapping("/getMerchant")
    public RestResponse getMerchant(){
        List<YjMerchant> list=merchantService.list(new QueryWrapper<YjMerchant>()
                        .select("address","enterprise_name","phone","banner","id")
                .eq("status",2));
        return new RestResponse().setSuccess(true).setData(list);
    }

    @ApiOperation("首页图标")
    @ApiImplicitParam(name = "merchantId", value = "商户ID", required = true, dataType = "String",  dataTypeClass = String.class)
    @PostMapping("/getIndex")
    public RestResponse getIndex(@RequestBody  YjIndex yjIndex){
        YjIndex y= indexService.getOne(new QueryWrapper<YjIndex>()
                .eq("merchant_id",yjIndex.getMerchantId()));

        if (ObjectUtil.isNotEmpty(y)){
            return new RestResponse().setSuccess(true).setData(y);
        }else {
            return new RestResponse().setSuccess(false);
        }


    }
}
