package com.ruoyi.web.controller.app_shop;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.RestResponse;
import com.ruoyi.shop.domain.YjMerchant;
import com.ruoyi.shop.service.impl.YjMerchantServiceImpl;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * 门店
 */
@Api(tags = "门店", description = "提供门店相关的API")
@RestController
@RequestMapping("/api/merchan")
public class MerchantController {

    @Resource
    private YjMerchantServiceImpl merchantService;
    /**
     *  企业简介+门店列表
     * @param merchan
     * @return
     */
    @ApiOperation(value = "创始人+企业简介+门店列表")
    @PostMapping("/getList")
    public RestResponse getList(@RequestBody YjMerchant merchan){
        YjMerchant m=merchantService.getOne(new QueryWrapper<YjMerchant>()
                        .select("id,enterprise_name,address,phone,founder,profile")
                .eq("id",merchan.getId()));
        return new RestResponse().setSuccess(true).setMessage("成功").setData(m);
    }


}
