package com.ruoyi.web.controller.app_shop;

import cn.hutool.core.date.DateTime;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.ruoyi.shop.domain.ShopOrder;
import com.ruoyi.shop.service.impl.ShopOrderServiceImpl;
import com.ruoyi.web.util.PayConstants;
import com.ruoyi.web.util.PayUtil;
import com.wechat.pay.contrib.apache.httpclient.WechatPayHttpClientBuilder;
import com.wechat.pay.contrib.apache.httpclient.auth.PrivateKeySigner;
import com.wechat.pay.contrib.apache.httpclient.auth.Verifier;
import com.wechat.pay.contrib.apache.httpclient.auth.WechatPay2Credentials;
import com.wechat.pay.contrib.apache.httpclient.auth.WechatPay2Validator;
import com.wechat.pay.contrib.apache.httpclient.cert.CertificatesManager;
import com.wechat.pay.contrib.apache.httpclient.util.PemUtil;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.util.EntityUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.BufferedReader;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.security.PrivateKey;
import java.text.SimpleDateFormat;
import java.util.*;

@RestController
@RequestMapping("/api")
public class PayController {
    @Resource
    private ShopOrderServiceImpl orderService;

    /**
     * 付款前
     * @param amount
     * @return
     * @throws Exception
     */
//    @PostMapping("/creat_order")
//    private Map creatOrder(int amount) throws  Exception{
//       return PayUtil.creatOrder("三朵兰",amount,"123");
//    }


    /**
     *
     * @return
     * https://www.test.com/callback
     */
    @PostMapping("/callback")
    public Map callback(HttpServletRequest request) {

        System.out.println("Wechatpay-Timestamp:"+ request.getHeader("Wechatpay-Timestamp"));
        System.out.println("Wechatpay-Nonce:"+ request.getHeader("Wechatpay-Nonce"));
        System.out.println("Wechatpay-Signature:"+ request.getHeader("Wechatpay-Signature"));
        System.out.println("Wechatpay-Serial:"+ request.getHeader("Wechatpay-Serial"));
        Map result=new HashMap();
        result.put("code","FAIL");

        try {
            StringBuilder signStr=new StringBuilder();
            signStr.append( request.getHeader("Wechatpay-Timestamp")).append("\n");
            signStr.append( request.getHeader("Wechatpay-Nonce")).append("\n");

            BufferedReader br=request.getReader();
            String str=null;
            StringBuilder builder=new StringBuilder();
            while ((str=br.readLine())!=null){
                builder.append(str);
            }
            System.out.println(builder);

            signStr.append( builder.toString()).append("\n");
            //验证签名
            if (!PayUtil.signVerify(request.getHeader("Wechatpay-Serial"),signStr.toString(),request.getHeader("Wechatpay-Signature"))){
                result.put("message","sign error");
                return result;
            }
            //解密密文
            String ciphertext=PayUtil.decryptOrder(builder.toString());
            System.out.println(ciphertext);
            //验证订单
            ObjectMapper objectMapper = new ObjectMapper();
            JsonNode node=objectMapper.readTree(ciphertext);
            JsonNode amount=node.get("amount");//订单金额信息
            String payer_total=amount.get("payer_total").textValue();//用户支付金额，单位为分
            String payer_currency=amount.get("payer_currency").textValue();//用户支付币种  示例值：CNY
            String trade_state=node.get("trade_state").textValue();//交易状态 SUCCESS
            String out_trade_no=node.get("out_trade_no").textValue();//商户订单号
            String success_time=node.get("success_time").textValue();//支付完成时间
            String transaction_id=node.get("transaction_id").textValue();//支付完成时间

            List<ShopOrder> list = orderService.list(new QueryWrapper<ShopOrder>().eq("orderSn",out_trade_no));
            //判断交易状态 可能是多次 SUCCESS； 也可能是 多次不同状态 ；
            // 现只处理支付成功与支付失败两种状态
            //判断是否处理过
            if (list.get(0).getPayStatus()==1){
                System.out.println("处理订单："+out_trade_no+" 交易状态："+trade_state);
                //支付失败
                if (trade_state.equals("PAYERROR")){
                    System.out.println("取消订单+关单");
                    orderService.cancelOrder(out_trade_no);
                    try {
                        PayUtil.closeOrder(out_trade_no);//关单
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
                //支付成功
                if (trade_state.equals("SUCCESS")){
                    System.out.println("支付成功");
                    orderService.paySuccess(out_trade_no
                            ,getStringByRFC3339(success_time)
                            ,transaction_id
                            ,payer_total);

                    result.put("code","SUCCESS");

                }
            }

        }catch (IOException e){
            e.printStackTrace();
        }
        return result;
    }


    public void a(@RequestBody Map<String,String> map){
        String out_trade_no=map.get("out_trade_no");
        String trade_state=map.get("trade_state");
        String success_time="2022-12-31T10:34:56+08:00";
        String transaction_id="微信支付订单号";
        String payer_total="0.1";

        List<ShopOrder> list = orderService.list(new QueryWrapper<ShopOrder>().eq("order_sn",out_trade_no));
        //判断交易状态 可能是多次 SUCCESS； 也可能是 多次不同状态 ；
        // 现只处理支付成功与支付失败两种状态
        //判断是否处理过
        if (list.get(0).getPayStatus()==1){
            //支付失败
            if (trade_state.equals("PAYERROR")){
                System.out.println("取消订单+关单");
                orderService.cancelOrder(out_trade_no);
                try {
                    PayUtil.closeOrder(out_trade_no);//关单
                    System.out.println("code,***");
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            //支付成功
            if (trade_state.equals("SUCCESS")){
                System.out.println("支付成功");
                orderService.paySuccess(out_trade_no
                        ,getStringByRFC3339(success_time)
                        ,transaction_id
                        ,payer_total);

                System.out.println("code,SUCCESS");

            }
        }
    }

    //查询订单
    public void queryOrder() throws Exception{
        PrivateKey merchantPrivateKey = PemUtil.loadPrivateKey(PayConstants.PRIVATE_KEY);
        // 获取证书管理器实例
        CertificatesManager certificatesManager = CertificatesManager.getInstance();
        // 向证书管理器增加需要自动更新平台证书的商户信息
        certificatesManager.putMerchant(PayConstants.MCH_ID, new WechatPay2Credentials(PayConstants.MCH_ID,
                        new PrivateKeySigner(PayConstants.MCH_SERIAL_NO, merchantPrivateKey)),
                PayConstants.API_V3KEY.getBytes(StandardCharsets.UTF_8));
        // 从证书管理器中获取verifier
        Verifier verifier = certificatesManager.getVerifier(PayConstants.MCH_ID);
        CloseableHttpClient httpClient = WechatPayHttpClientBuilder.create()
                .withMerchant(PayConstants.MCH_ID, PayConstants.MCH_SERIAL_NO, merchantPrivateKey)
                .withValidator(new WechatPay2Validator(certificatesManager.getVerifier(PayConstants.MCH_ID)))
                .build();
//***********************
        URIBuilder uriBuilder = new URIBuilder("https://api.mch.weixin.qq.com/v3/pay/partner/transactions/id/"+"订单号"+"?mchid="+PayConstants.MCH_ID);
        HttpGet httpGet = new HttpGet(uriBuilder.build());
        httpGet.addHeader("Accept", "application/json");

        CloseableHttpResponse response = httpClient.execute(httpGet);

        String bodyAsString = EntityUtils.toString(response.getEntity());
        System.out.println(bodyAsString);
    }

    /**
     * 支付成功时间格式化
     *
     *  遵循rfc3339标准格式
     *   格式为yyyy-MM-DDTHH:mm:ss+TIMEZONE
     *   示例值：2018-06-08T10:34:56+08:00
     * @param dateStr
     * @return
     */
    public static String getStringByRFC3339(String dateStr){
        DateTime dateTime = new DateTime(dateStr);
        long timeInMillis = dateTime.toCalendar(Locale.getDefault()).getTimeInMillis();
        Date date = new Date(timeInMillis);

        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = format.format(date);
        return time;
    }
}
