package com.ruoyi.web.controller.app_shop;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.RestResponse;
import com.ruoyi.shop.domain.YjPracticeMoments;
import com.ruoyi.shop.service.impl.YjPracticeMomentsServiceImpl;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * 练习瞬间
 */
@Api(tags = "练习瞬间", description = "提供练习瞬间相关的API")
@RestController
@RequestMapping("/api/moments")
public class PracticeMomentsController {

    @Resource
    private YjPracticeMomentsServiceImpl momentsService;

    /**
     * 练习瞬间列表
     * @param moments
     * @return
     */
    @ApiOperation(value = "获取练习瞬间列表")
    @PostMapping("/getList")
    public RestResponse getList(@RequestBody YjPracticeMoments moments){
        List<YjPracticeMoments> list=momentsService.list(new QueryWrapper<YjPracticeMoments>()
                .eq("merchan_id",moments.getMerchanId())
                .eq("status",true)
                .orderByDesc("modify_time"));
        return new RestResponse().setSuccess(true).setMessage("成功").setData(list);
    }

    /**
     * 练习瞬间详情
     * @param moments
     * @return
     */
    @ApiOperation(value = "获取练习瞬间详情")
    @PostMapping("/getOne")
    public RestResponse getOne(@RequestBody YjPracticeMoments moments){
        YjPracticeMoments m=momentsService.getOne(new QueryWrapper<YjPracticeMoments>()
                .eq("id",moments.getId()));
        return new RestResponse().setSuccess(true).setMessage("成功").setData(m);
    }
}
