package com.ruoyi.web.controller.app_shop;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.RestResponse;
import com.ruoyi.shop.domain.ShopCart;
import com.ruoyi.shop.domain.ShopGoods;
import com.ruoyi.shop.mapper.ShopCartMapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;
@Api(tags = "购物车", description = "提供购物车相关的API")
@RestController
@RequestMapping("/api/shopCart")
public class ShopCartController {

    @Resource
    private ShopCartMapper shopCartMapper;

    @ApiOperation("加入购物车")
    @PostMapping("/addShopCart")
    public RestResponse addShopCart(@RequestBody ShopCart shopCart, HttpServletRequest request){
        Long userId= Long.parseLong(request.getAttribute("userId").toString());
        ShopCart s=shopCartMapper.selectOne(new QueryWrapper<ShopCart>()
                .eq("id_user",userId)
                .eq("id_goods",shopCart.getIdGoods()));
        if (ObjectUtil.isNotEmpty(s)){
            s.setCount(s.getCount()+1);
            shopCartMapper.updateById(s);
            return new RestResponse().setSuccess(true).setMessage("成功");
        }
        shopCart.setIdUser(userId);
        shopCartMapper.insert(shopCart);
        return new RestResponse().setSuccess(true).setMessage("成功");
    }

    @ApiOperation("购物车删除商品")
    @PostMapping("/removeShopCart")
    public RestResponse removeShopCart(@RequestBody Map<String, List<String>> map){
        List<String> ids=map.get("ids");
        shopCartMapper.deleteBatchIds(ids);
        return new RestResponse().setSuccess(true).setMessage("成功");
    }

    @ApiOperation("购物车商品列表")
    @PostMapping("/shopCartList")
    public RestResponse shopCartList(HttpServletRequest request){
        Long userId= Long.parseLong(request.getAttribute("userId").toString());
        List<ShopGoods> list=shopCartMapper.cartList(userId);
        return new RestResponse().setSuccess(true).setMessage("成功").setData(list);
    }

    @ApiOperation("购物车修改商品数量")
    @PostMapping("/changeCount")
    public RestResponse changeCount(@RequestBody ShopCart shopCart){
        shopCartMapper.updateById(shopCart);
        return new RestResponse().setSuccess(true).setMessage("成功");
    }

}
