package com.ruoyi.framework.config;

import io.jsonwebtoken.Claims;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


//拦截器

public class LoginInterceptor implements HandlerInterceptor {

    @Autowired
    private JwtUtil1 jwtUtil1;

    //加载时机:处理器拦截用的，该方法将在Controller处理之前进行调用
    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        String token = request.getHeader("token");
        if (token==null||token.equals("")) {
            response.setStatus(401);
            return false;
        }
        Claims claims = jwtUtil1.getClaimByToken(token);
        //token失效
        if (claims == null ) {
            response.setStatus(401);//|| jwtUtil.isTokenExpired(claims.getExpiration())
            return false;
        }
        request.setAttribute("userId",claims.getId());
        request.setAttribute("phone",claims.get("phone"));
        return true;
    }

    @Override
    public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {

    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {

    }

}
