package com.ruoyi.course.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.utils.StringUtils;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.List;

/**
 * <p>
 * 课程记录
 * </p>
 *
 * @author xhj
 * @since 2022-09-23
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class CourseLog  implements Serializable {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    private Integer courseId;

    private String startDate;

    private String startTime;

    private String endTime;

    private Integer number;

    private Integer tearcher;

    private String place;

    private Integer appointmentNum;

    private LocalDateTime createTime;

     //价格")
     @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal coursePrice;

     //长视频")
    private String videoLong;

     //短视频")
    private String videoShort;

     //类型 大咖，普通")
    private String memberType;

     //大咖1 大咖 2 大咖3 ")
    private String courseType;

     //具体分类")
    private String courseType1;

     //课程名字")
    private String courseNames;

     //客程内容")
    private String courseContext;

     //图片")
    private String coursePicture;

    private String releases;

    private String  sourceTime;


//    private   sourceLpId;

    @TableField(exist = false)
    private String endDate;//结束日期

    @TableField(exist = false)
    private String week;//周几上课 周日1 周一2

    @TableField(exist = false)
    private List memberNum;

    //流派id
    private Integer lpId;

    public void generateMemberNum(){

        if (StringUtils.isNotBlank(memberType)) {
            if (memberType.length() == 1) {
                setMemberNum(Arrays.asList(memberType));
            } else {
                String[] str = memberType.split(",");
                setMemberNum(Arrays.asList(str));
            }
        }
    }

}
