package com.ruoyi.course.service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.course.domain.CourseLog;
import com.ruoyi.course.mapper.CourseLogMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;

/**
 * <p>
 * 课程记录 服务实现类
 * </p>
 *
 * @author xhj
 * @since 2022-09-23
 */
@Service
public class CourseLogServiceImpl extends ServiceImpl<CourseLogMapper, CourseLog>  {

    @Resource
    private CourseLogMapper mapper;

    public void addLog(CourseLog courseLog){

        mapper.emptyLog(courseLog);//清空 同一个教练+课程 今天之后的没人预约的课
        //开始时间
        String start=courseLog.getStartDate();
        //结束时间
        String end=courseLog.getEndDate();
        //周几
        String[] week= courseLog.getWeek().split(",");

        SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
        Calendar cal=Calendar.getInstance();
        try {
            cal.setTime(sdf.parse(start));

            while (sdf.parse(start).before(sdf.parse(end)) || sdf.parse(start).equals(sdf.parse(end))){
                for (String w:week){
                   int i= cal.get(Calendar.DAY_OF_WEEK);
                    if (i==Integer.parseInt(w)){
                        System.out.println(sdf.format(cal.getTime()));
                        courseLog.setStartDate(sdf.format(cal.getTime()));
                        save(courseLog);
                        courseLog.setId(null);
                    }
                }
                cal.add(Calendar.DATE,1);
                start=sdf.format(cal.getTime());
            }
        }catch (ParseException e){
            e.printStackTrace();
        }
    }

}
