package com.ruoyi.course.service;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.course.domain.*;
import com.ruoyi.course.mapper.CourseLogMapper;
import com.ruoyi.course.mapper.CourseMapper;
import com.ruoyi.search.domain.MemberUser;
import com.ruoyi.search.service.MemberUserServicelmpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class CourseServiceImpl extends ServiceImpl<CourseMapper, Course> {


    @Autowired
    CourseMapper courseMapper;

    @Autowired
    CourseLogServiceImpl courseLogService;

    @Autowired
    CourseLogMapper courseLogMapper;

    @Autowired
    AppointmentServiceImpl appointmentService;
    @Autowired
    MemberUserServicelmpl memberUserService;

    public List<Course> getList(Map map) {

        List<Course> list = courseMapper.findList(map);
        list.forEach(e -> {
            if (StringUtils.isNotBlank(e.getMemberType())) {
                if (e.getMemberType().length() == 1) {
                    e.setMemberNum(Arrays.asList(e.getMemberType()));
                } else {
                    String[] str = e.getMemberType().split(",");

                    e.setMemberNum(Arrays.asList(str));
                }
            }
        });

        if (ObjectUtil.isEmpty(list)){
            System.out.println();
        }
        return list;
    }



    public List<CourseLogVo> getListLog(Map map) {

        List<CourseLogVo> list = courseMapper.findLog(map);
        list.forEach(e -> {
            if (StringUtils.isNotBlank(e.getMemberType())) {
                if (e.getMemberType().length() == 1) {
                    e.setMemberNum(Arrays.asList(e.getMemberType()));
                } else {
                    String[] str = e.getMemberType().split(",");

                    e.setMemberNum(Arrays.asList(str));
                }
            }


        });
        return list;

    }



    /**
     * 预约课程
     */
    public void yyCourse(Appointment appointment) {
        appointment.setCreateTime(DateUtil.parseLocalDateTime(DateUtil.now(), "yyyy-MM-dd HH:mm:ss"));
        CourseLog courseLog = new CourseLog();
        courseLogMapper.updateAppointmentNum(appointment.getCourseLogId());
    }


    public void yyCourse1(Appointment appointment) {
        appointment.setCreateTime(DateUtil.parseLocalDateTime(DateUtil.now(), "yyyy-MM-dd HH:mm:ss"));
        appointmentService.save(appointment);
    }

    /**
     * 查询课程表内的课程
     *
     * @param map
     */
    public Map listLogDate(Map map) {
        //获取本周日期
        String type = (String) map.get("type");
        String date = (String) map.get("date");
        Integer courseId = (Integer) map.get("courseId");
        String end = "";
        String start = "";
//        if ("now".equals(type)) {
            DateTime starttime = DateUtil.beginOfWeek(DateUtil.date());
            DateTime endtime = DateUtil.endOfWeek(DateUtil.date());
            start = DateUtil.format(starttime, "yyyy-MM-dd");
            end = DateUtil.format(endtime, "yyyy-MM-dd");
//        } else if ("next".equals(type)) {
//
//        } else if ("up".equals("type")) {
//
//        }

        Map queryMap = new HashMap();
        queryMap.put("beginCreateTime", start);
        queryMap.put("endCreateTime", end);
        queryMap.put("courseType", "1");
        List<CourseLogVo> logList = courseMapper.findLog(queryMap);
        // 确定有几个时间短 通过开始时间
        QueryWrapper<CourseLog> eq = new QueryWrapper<CourseLog>().select("DISTINCT start_time,end_time").eq(!(null==courseId), "course_id", courseId).orderBy(true, true, "start_time");
        List<CourseLog> list = courseLogService.list(eq);
        List<Map<String, String>> timeList = new ArrayList<>();

        int num = 1;
        for (CourseLog courseLog : list) {

            Map mapTime = new HashMap();
            mapTime.put("index", num);
            mapTime.put("name", courseLog.getStartTime() + "\\n" + courseLog.getEndTime());
            timeList.add(mapTime);
//            temp.add(mapTime);
            num++;
        }

        List<List<Map<String, String>>> weeks = new ArrayList<>();

        for (int i = 1; i <= 7; i++) {
            List<List<Map>> courseName = new ArrayList<>();
//
////            temp=timeList;
////            List<Map<String, String>> temp= new ArrayList<>(timeList);
//            temp.addAll(timeList);
            List<Map<String, String>> temp = new ArrayList<>();
            for (Map time : timeList) {

                Map map1= new HashMap();
                map1.put("index", time.get("index"));
                map1.put("name", time.get("name"));
                for (CourseLogVo courseLogVo : logList) {
                    int day = DateUtil.dayOfWeek(DateUtil.parse(courseLogVo.getStartDate()));
                    if (i == day) {
                        if (time.get("name").equals(courseLogVo.getStartTime() + "\\n" + courseLogVo.getEndTime())) {
//                            time.put("courseName",courseLogVo.getCourseNames());
                            map1.put("courseName", courseLogVo.getCourseNames());
                        }
                        System.out.println("i = " + i);

                    }

                }
                temp.add(map1);

            }

            weeks.add(temp);

        }
        List<Map> index=new ArrayList<>();
        List<List<String>>name = new ArrayList<>();
        for(List<Map<String,String>> item :weeks){
            List<String>itemList=new ArrayList<>();
            for(Map itemMap  : item){
                if(StringUtils.isNotBlank((String)itemMap.get("courseName"))){
                    itemList.add((String)itemMap.get("courseName"));
                }else{
                    itemList.add("");
                }

            }
            name.add(itemList);
        }
        Map returnMap = new HashMap();
        returnMap.put("timeList", timeList);
        returnMap.put("name", name);
        return returnMap;


    }

    /**
     * 查询课程表内的课程
     *
     * @param map
     */
    public Map listLogDate1(Map map) {
        //获取本周日期
        Integer courseId = (Integer) map.get("courseId");
        String end = (String) map.get("end");
        String start = (String) map.get("start");

        //查询开始日期（start_date）在本周日期范围内的开课记录
        Map queryMap = new HashMap();
        queryMap.put("beginCreateTime", start);
        queryMap.put("endCreateTime", end);
        queryMap.put("courseType", "1");
        queryMap.put("courseId", courseId);
        List<CourseLogVo> logList = courseMapper.findLog1(queryMap);

        // 确定有几个时间段 通过上课时间
        QueryWrapper<CourseLog> eq = new QueryWrapper<CourseLog>().select("DISTINCT start_time,end_time").eq(!(null==courseId), "course_id", courseId)
                .between("start_date",start,end)
                .orderBy(true, true, "start_time");

        List<CourseLog> list = courseLogService.list(eq);

        //循环上课时间，加入index ，成为y轴
        List<Map<String, String>> timeList = new ArrayList<>();
        int num = 1;
        for (CourseLog courseLog : list) {
            Map mapTime = new HashMap();
            mapTime.put("index", num);
            mapTime.put("name", courseLog.getStartTime() + "-" + courseLog.getEndTime());
            timeList.add(mapTime);
            num++;
        }

        //在本周填数据
        List<List<Map<String, String>>> weeks = new ArrayList<>();

//判断是否为会员
        if (ObjectUtil.isNotEmpty(map.get("userId"))){
            List<MemberUser> memberUserList=getMembers( map.get("userId").toString());
            if (ObjectUtil.isNotEmpty(memberUserList)){
                for (int i = 1; i <= 7; i++) {
                    List<Map<String, String>> temp = new ArrayList<>();

                    //循环上课时间
                    for (Map time : timeList) {

                        Map map1= new HashMap();
                        map1.put("index", time.get("index"));
                        map1.put("name", time.get("name"));
                        for (CourseLogVo courseLogVo : logList) {
                            int day = DateUtil.dayOfWeek(DateUtil.parse(courseLogVo.getStartDate()));
                            day=day-1==0?7:day-1;
                            if (i == day){
                                if (time.get("name").equals(courseLogVo.getStartTime() + "-" + courseLogVo.getEndTime())) {
                                    //判断会籍类型是否可以预约
                                    for (MemberUser memberUser:memberUserList){
                                        for (Object m:courseLogVo.getMembers()){
                                            if (memberUser.getMemberId()==Integer.parseInt(m.toString())){
                                                map1.put("courseName", "*"+courseLogVo.getCourseNames()+courseLogVo.getId());
                                            }else {
                                                map1.put("courseName", courseLogVo.getCourseNames()+courseLogVo.getId());
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        temp.add(map1);
                    }
                    weeks.add(temp);
                }
            }else {
                for (int i = 1; i <= 7; i++) {
                    List<Map<String, String>> temp = new ArrayList<>();

                    //循环上课时间
                    for (Map time : timeList) {

                        Map map1= new HashMap();
                        map1.put("index", time.get("index"));
                        map1.put("name", time.get("name"));
                        for (CourseLogVo courseLogVo : logList) {
                            int day = DateUtil.dayOfWeek(DateUtil.parse(courseLogVo.getStartDate()));
                            day=day-1==0?7:day-1;
                            if (i == day){
                                if (time.get("name").equals(courseLogVo.getStartTime() + "-" + courseLogVo.getEndTime())) {
                                    map1.put("courseName", courseLogVo.getCourseNames()+courseLogVo.getId());
                                }
                            }
                        }
                        temp.add(map1);
                    }
                    weeks.add(temp);
                }
            }
        }else {
            for (int i = 1; i <= 7; i++) {
                List<Map<String, String>> temp = new ArrayList<>();

                //循环上课时间
                for (Map time : timeList) {

                    Map map1= new HashMap();
                    map1.put("index", time.get("index"));
                    map1.put("name", time.get("name"));
                    for (CourseLogVo courseLogVo : logList) {
                        int day = DateUtil.dayOfWeek(DateUtil.parse(courseLogVo.getStartDate()));
                        day=day-1==0?7:day-1;
                        if (i == day){
                            if (time.get("name").equals(courseLogVo.getStartTime() + "-" + courseLogVo.getEndTime())) {
                                map1.put("courseName", courseLogVo.getCourseNames()+courseLogVo.getId());
                            }
                        }
                    }
                    temp.add(map1);
                }
                weeks.add(temp);
            }
        }

//将课程名称单拎出来
        List<List<String>>name = new ArrayList<>();
        for(List<Map<String,String>> item :weeks){
            List<String>itemList=new ArrayList<>();
            for(Map itemMap  : item){
                if(StrUtil.isNotBlank((String)itemMap.get("courseName"))){

                    itemList.add((String) itemMap.get("courseName"));

                }else{
                    itemList.add("");
                }
            }
            name.add(itemList);
        }

        Map returnMap = new HashMap();
        returnMap.put("timeList", timeList);
        returnMap.put("name", name);
        return returnMap;


    }

    public List<MemberUser> getMembers(String userId){
            List<MemberUser> memberUserList= memberUserService.list(new QueryWrapper<MemberUser>()
                    .select("member_id")
                    .eq("consumer_id",userId)
                    .last("and validity_time>now()"));
            return   memberUserList;
    }

    public List<Course> listForApp(Course course){
        List<Course> list=courseMapper.listForApp(course);
        return list;
    }

    public Context getTeacherPhone(Integer logId){
       return courseMapper.getTeacherPhone(logId);
    }


}
