package com.ruoyi.search.service;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.search.domain.MemberUser;
import com.ruoyi.search.domain.MemberUserWo;
import com.ruoyi.search.mapper.MemberUserMapper;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

@Service
public class MemberUserServicelmpl extends ServiceImpl<MemberUserMapper , MemberUser > {


    public List<MemberUserWo> getList(Map map){
        List<MemberUserWo> list = baseMapper.findList(map);
        return list;
    }

    public Boolean handleMember(MemberUser memberUser) {
        LocalDateTime dateTime= DateUtil.parseLocalDateTime(DateUtil.format(DateUtil.tomorrow(),"yyyy-MM-dd 00:00:00"));
        List<MemberUser> list=this.list(new QueryWrapper<MemberUser>()
                .eq("member_id",memberUser.getMemberId())
                .eq("consumer_id",memberUser.getConsumerId())
                .last(" and (validity_time > now() or come_time ='"+dateTime+"')"));//截止日期为今天之后（未到期） 或 开始日期在明天（今天办的）
        if (list.size()>0){
            System.out.println("会籍存续中，请勿重复办理！");
            return false;
        }

        //入会时间 次日生效
        memberUser.setComeTime(dateTime);

        //截止日期
        Calendar cal = Calendar.getInstance();
        cal.setTime(DateUtil.tomorrow());
        cal.add(Calendar.MONTH,memberUser.getValidity());
        memberUser.setValidityTime(DateUtil.format(cal.getTime(),"yyyy-MM-dd"));
        return this.save(memberUser);
    }


}
