package com.ruoyi.shop.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 消费者用户表
 * </p>
 *
 * @since 2022-09-27
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class Consumer implements Serializable {

    private static final long serialVersionUID=1L;

    /**
     * 用户ID
     */
    @TableId(value = "consumer_id", type = IdType.AUTO)
    private Long consumerId;

    /**
     * 用户账号
     */
    @ApiModelProperty("用户账号")
    private String consumerName;

    /**
     * 用户昵称
     */
    @ApiModelProperty("用户昵称")
    private String consumerNickName;

    /**
     * 用户类型（00系统用户）
     */
    private String consumerType;

    /**
     * 用户邮箱
     */
    private String consumerEmail;

    /**
     * 手机号码
     */
    @ApiModelProperty("手机号码")
    private String consumerPhonenumber;

    /**
     * 用户性别（0男 1女 2未知）
     */
    @ApiModelProperty("用户性别（0男 1女 2未知）")
    private String consumerSex;

    /**
     * 头像地址
     */
    @ApiModelProperty("头像")
    private String consumerAvatar;

    /**
     * 密码
     */
    @ApiModelProperty("密码")
    private String consumerPassword;

    /**
     * 帐号状态（0正常 1停用）
     */
    private String consumerStatus;

    /**
     * 删除标志（0代表存在 2代表删除）
     */
    private String consumerDelFlag;

    /**
     * 推荐人id
     */
    @ApiModelProperty("推荐人id")
    private String recommendId;

    /**
     * 创建者
     */
    private String createBy;

    /**
     * 创建时间
     */
     @JsonFormat(shape = JsonFormat.Shape.STRING, pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime createTime;

    /**
     * 更新者
     */
    private String updateBy;

    /**
     * 更新时间
     */
     @JsonFormat(shape = JsonFormat.Shape.STRING, pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime updateTime;

    /**
     * 备注
     */
    @ApiModelProperty("备注")
    private String remark;

    /**
     * 设备id
     */
    @ApiModelProperty("设备id")
    private String registerId;

    @ApiModelProperty("角色，0顾客 103会籍顾问 104教练 105店长")
    private String role;

    @ApiModelProperty("当前门店id")
    private String merchantId;
}
