package com.ruoyi.shop.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 用户地址
 * </p>
 *
 * @author xn
 * @since 2022-09-29
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class ShopAddress implements Serializable {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String id;

    /**
     * 用户id
     */
    private Long userId;

    /**
     * 省
     */
    @ApiModelProperty("商品简介")
    private String province;

    /**
     * 市
     */
    @ApiModelProperty("商品简介")
    private String city;

    /**
     * 详细地址
     */
    @ApiModelProperty("详细地址")
    private String address;

    /**
     * 是否默认
     */
    @ApiModelProperty("是否默认")
    private Boolean isDefault;

     @JsonFormat(shape = JsonFormat.Shape.STRING, pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime addTime;

    /**
     * 电话
     */
    @ApiModelProperty("电话")
    private String phone;

    /**
     * 收货人名称
     */
    @ApiModelProperty("收货人名称")
    private String name;


}
