package com.ruoyi.shop.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * <p>
 * 商品表
 * </p>
 *
 * @author xn
 * @since 2022-09-22
 */
@Data
public class ShopGoods implements Serializable {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String id;

    /**
     * 商品名称
     */
    @ApiModelProperty("商品名称")
    private String name;

    /**
     * 商品缩略图
     */
    @ApiModelProperty("商品缩略图")
    private String thumbnail;

    /**
     * 类别id，二级类别
     */
    @ApiModelProperty("类别id，二级类别")
    private String categoryId;

    /**
     * 商品简介
     */
    @ApiModelProperty("商品简介")
    private String brief;

    /**
     * 是否上架
     */
    private Boolean isSale;

    /**
     * 是否推荐
     */
    @ApiModelProperty("类别名称")
    private Boolean recommend;

    /**
     * 商品相册,多张图片url，用逗号间隔
     */
    @ApiModelProperty("商品相册")
    private String album;

    /**
     * 商品详情,富文本
     */
    @ApiModelProperty("商品详情")
    private String detail;

    /**
     * 库存
     */
    @ApiModelProperty("库存")
    private Integer stock;

    /**
     * 销售数量
     */
    @ApiModelProperty("销售数量")
    private Integer salesNum;

    /**
     * 保底价格
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal minimumPrice;

    /**
     * 市场价
     */
    @ApiModelProperty("市场价")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal marketPrice;

    /**
     * 售价
     */
    @ApiModelProperty("售价")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private BigDecimal price;

    /**
     * 创建时间
     */
     @JsonFormat(shape = JsonFormat.Shape.STRING, pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime createTime;

    /**
     * 创建人id
     */
    private Long createBy;

    /**
     * 最后修改人id
     */
    private Long modifyBy;

    /**
     * 最后修改时间
     */
     @JsonFormat(shape = JsonFormat.Shape.STRING, pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime modifyTime;

    /**
     * 规格
     */
    @ApiModelProperty("规格")
    private String attribute;

    /**
     * 所属商户id
     */
    private String businessId;

    @TableField(exist = false)
    private String cartId;

    @TableField(exist = false)
    private String count;
}
