package com.ruoyi.shop.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 商品类别表
 * </p>
 *
 * @author xn
 * @since 2022-09-22
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class ShopGoodsCategory implements Serializable {

    private static final long serialVersionUID=1L;



    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String id;

    /**
     * 父类别id，一级默认值0
     */

    private String pid;

    /**
     * 类别名称
     */
    @ApiModelProperty("类别名称")
    private String name;



    /**
     * 描述
     */
    @ApiModelProperty("描述")
    private String detail;

    /**
     * 图片
     */
    @ApiModelProperty("图片")
    private String picture;

    /**
     * 顺序
     */
    @ApiModelProperty("顺序")
    private Integer sort;

    /**
     * 是否页面显示
     */
    @ApiModelProperty("是否页面显示")
    private Boolean display;

    /**
     * 创建时间
     */
     @JsonFormat(shape = JsonFormat.Shape.STRING, pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime createTime;

    /**
     * 创建人id
     */
    private Long createBy;

    /**
     * 最后更新人id
     */
    private Long modifyBy;

    /**
     * 最后更新时间
     */
     @JsonFormat(shape = JsonFormat.Shape.STRING, pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime modifyTime;

    /**
     * 是否已删除
     */
    private Boolean isDelete;

    /**
     * 所属商户id
     */
    @ApiModelProperty("所属商户id")
    private String businessId;

    @TableField(exist = false)
    private List<ShopGoodsCategory> child;


}
