package com.ruoyi.shop.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * <p>
 * 订单明细
 * </p>
 *
 * @author xn
 * @since 2022-09-23
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class ShopOrderItem implements Serializable {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String id;

    /**
     * 最后更新时间
     */
    @ApiModelProperty("最后更新时间")
     @JsonFormat(shape = JsonFormat.Shape.STRING, pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime modifyTime;

    /**
     * 数量
     */
    @ApiModelProperty("数量")
    private String count;

    /**
     * 商品id
     */
    @ApiModelProperty("商品id")
    private String idGoods;

    /**
     * 所属订单id
     */
    @ApiModelProperty("所属订单id")
    private String idOrder;

    /**
     * 单价
     */
    @ApiModelProperty("单价")
    private BigDecimal price;

    /**
     * 合计
     */
    @ApiModelProperty("合计")
    private BigDecimal totalPrice;
    //* 缩略图
    @ApiModelProperty("缩略图")
    private String thumbnail;
    //* 商品简介
    @ApiModelProperty("商品简介")
    private String brief;
    //* 规格
    @ApiModelProperty("规格")
    private String attribute;


    // 开课记录id
    private Integer idSouseLog;

    // "会员id
    private Integer idMember;

    // "商品名称
    private String goodsName;

    // "1 商品 2 会籍 3  课程
    private String type;

    // "会籍有效期
    private Integer memberValidity;

    // "课程内容
    private String courseContext;

    //课程说明")
    private String courseExplain;

    //会籍类型")
    private String memberType;

    //课程类型 2大咖 3教练培训")
    private String courseType;

    //大咖1 大咖 2 大咖3 具体分类")
    private String courseType1;
    // 上课日期
    private String   startDate;
    // 上课时间
    private String  startTime;
    //上课时长
    private String sourceTime;
    //上课地点
    private String place;
    //课程名称
    private String courseNames;
    //会籍推荐人 电话号
    private String memberRecommend;
    @TableField(exist = false)
    private ShopGoods goods;



}
