package com.ruoyi.shop.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.ruoyi.course.domain.CourseLog;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.List;

/**
 * <p>
 * 瑜伽流派
 * </p>
 *
 * @author xn
 * @since 2022-10-31
 */
@ApiModel(description= "瑜伽流派及对应课程")
@Data
@EqualsAndHashCode(callSuper = false)
public class YjCourseLp implements Serializable {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 流派名称
     */
    @ApiModelProperty("流派名称")
    private String name;

    /**
     * 图标
     */
    @ApiModelProperty("图标")
    private String img;

    /**
     * 商户id
     */
    private String merchantId;

    private Boolean enabled;

    @ApiModelProperty("当前流派下的课程")
    @TableField(exist = false)
    private List<CourseLog> courseList;

    @ApiModelProperty("课程分类 2大咖课 3教练培训")
    @TableField(exist = false)
    private String courseType;//课程分类 2大咖课 3教练培训

    @TableField(exist = false)
    private Boolean releases;
    /**
     * 简介
     */
    @ApiModelProperty("简介")
    private String context;
}
