package com.ruoyi.shop.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 商户表
 * </p>
 *
 * @author xn
 * @since 2022-09-28
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class YjMerchant implements Serializable {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String id;

    /**
     * 负责人id
     */
    private Long responsibleId;//负责人id

    private String businessLicense;//营业执照编号/统一信用编码

    private byte[] businessLicensePicture;//营业执照照片/扫描件

    private String legalPerson;//法人姓名

    private String legalPersonTel;//法人联系方式

    private String legalPersonCard;//法人证件号码

    private byte[] legalPersonCardPicturePositive;//法人证件照片/扫描件正面

    private byte[] legalPersonCardPictureBack;//法人证件照片/扫描件背面

    private String vip;//付费级别

    private String vipPrice;//付费金额

    private String vipPriceType;//付费方式,试用,年付,终身/长期

    private String vipPayType;//支付方式,支付宝,微信,转账银行

    private String bankCardId;//银行转账账号

    private Date validUntil;//有效期至,终身/长期用户不判断

    private Date reminderDate;//年付用户预付款提醒开始日期,提醒截止日期到宽限期结束

    private Integer gracePeriod;//宽限期

    /**
     * 是否正常运营
     */
    private Integer status;//状态 0申请,1审核中,2审核通过,3停止运营

    @ApiModelProperty("banner图")
    private String banner;//banner图
    @ApiModelProperty("企业名称")
    private String enterpriseName;//企业名称

    private String address;
    private String phone;

    @TableField(exist = false)
    private String legalPersonCardPicturePositive1;//法人证件照片/扫描件正面

    @TableField(exist = false)
    private String legalPersonCardPictureBack1;//法人证件照片/扫描件背面

    @TableField(exist = false)
    private String businessLicensePicture1;//营业执照照片/扫描件

}
