package com.ruoyi.shop.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 *
 * </p>
 *
 * @author xn
 * @since 2022-09-26
 */
@ApiModel(description= "练习瞬间信息")
@Data
@EqualsAndHashCode(callSuper = false)
public class YjPracticeMoments implements Serializable {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String id;
    /**
     * 标题
     */
    @ApiModelProperty("标题")
    private String title;

    /**
     * 封面
     */
    @ApiModelProperty("封面")
    private String image;

    /**
     * 阅读量
     */
    @ApiModelProperty("阅读量")
    private Integer readNum;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime startTime;

    /**
     * 内容（富文本）
     */
    @ApiModelProperty("内容（富文本）")
    private String content;

    /**
     * 是否展示
     */
    private Boolean status;

    /**
     * 修改时间
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime modifyTime;

    /**
     * 所属商户id
     */
    private String merchanId;
}
